# PloneMall tests

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from PloneMallTestCase import PloneMallTestCase
from Testing import ZopeTestCase

class TestQuickInstallerTool(PloneMallTestCase):

    def afterSetUp(self):
        self.qi = self.portal.portal_quickinstaller

    def testSetup(self):
        self.qi.installProduct("Archetypes")
        self.qi.installProduct("PloneFormMailer")
        self.qi.installProduct("PloneMall")

        # Registry
        self.qi.installProduct("PloneMallRegistry")
        for t in ('MallRegistryTool',):
            assert t in self.portal.portal_types.objectIds()

        # Item
        self.qi.installProduct("PloneMallItem")
        for t in ('SimpleItem', 'AdvancedItem', 'ItemVariant', 'Category'):
            assert t in self.portal.portal_types.objectIds()

        # Customer
        self.qi.installProduct("PloneMallCustomer")
        for t in ('CustomerInformation', 'AddressInformationSet', 'AddressInformation', 'AVS'):
            assert t in self.portal.portal_types.objectIds()

        # Cart
        self.qi.installProduct("PloneMallCart")
        for t in ('Cart', 'CartItem', 'CartManager'):
            assert t in self.portal.portal_types.objectIds()

        # Order
        self.qi.installProduct("PloneMallOrder")
        for t in ('Order', 'MailOrder', 'OrderManager'):
            assert t in self.portal.portal_types.objectIds()

        # Shipping
        self.qi.installProduct("PloneMallShipping")
        for t in ('ShippingInformation',):
            assert t in self.portal.portal_types.objectIds()

        # Payment
        self.qi.installProduct("PloneMallPayment")
        for t in ('PaymentInformation',):
            assert t in self.portal.portal_types.objectIds()

        # Tax
        self.qi.installProduct("PloneMallTax")
        for t in ('RegionTax', 'RegionTaxInformation', 'TaxInformationSet', 'TaxInformation'):
            assert t in self.portal.portal_types.objectIds()
 
        # Demo       
        self.qi.installProduct("PloneMallDemo")
        for t in ('Demo',):
            assert t in self.portal.portal_types.objectIds()

if __name__ == '__main__':
    framework()
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestQuickInstallerTool))
        return suite
