# PloneMallRegistry tests

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from PloneMallTestCase import PloneMallTestCase
from Testing import ZopeTestCase
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

class TestPloneMallRegistry(PloneMallTestCase):

    def afterSetUp(self):
        self.qi = self.portal.portal_quickinstaller
        self.qi.installProduct("Archetypes")
        self.qi.installProduct("PloneFormMailer")
        self.qi.installProduct("PloneMall")
        self.qi.installProduct("PloneMallRegistry")
        self.qi.installProduct("PloneMallItem")
        self.qi.installProduct("PloneMallCustomer")
        self.qi.installProduct("PloneMallCart")
        self.qi.installProduct("PloneMallOrder")
        self.qi.installProduct("PloneMallShipping")
        self.qi.installProduct("PloneMallPayment")
        self.qi.installProduct("PloneMallTax")
        self.qi.installProduct("PloneMallDemo")

    def testPloneMallMallRegistry(self):
        
	l_interfaces = ['IAVS', 'IAddressInformation', 'IAddressInformationSet', 
                        'ICart', 'ICartItem', 'ICartManager', 'ICategorizeable', 
                        'ICategory', 'ICustomerInformation', 'IMallItem', 'IOrder', 
                        'IOrderManager', 'IPaymentInformation', 'IPaymentMethod', 
                        'IPhysicalItem', 'IShippingInformation', 'IShippingMethod', 
                        'ITaxInformation', 'ITaxInformationSet', 'ITaxMethod']

        for iface_name in l_interfaces:
            iface = FactoryRegistry.getInterfaceDefinition(iface_name)
            self.failIf(type(iface) in (type(''), type(u'')))

        iface_ids = FactoryRegistry.getInterfaceIds()
	iface_ids.sort()
	self.failUnless(l_interfaces == iface_ids)

if __name__ == '__main__':
    framework()
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestPloneMallRegistry))
        return suite
