# File: CartManager.py
"""\
Cart Manager

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.ICartManager import ICartManager



from Products.PloneMallCart.config import *


from Products.CMFCore.utils import UniqueObject,getToolByName

    
##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.AllowedTypesByIface import AllowedTypesByIface
##/code-section module-header

from zLOG import LOG,INFO,DEBUG

schema= Schema((
    StringField('select_mode',
        default="checkbox",
        widget=SelectionWidget
        (
            description="Shal checkoxes or editboxes be dsplayed with each item",
            label="Select Mode",
            label_msgid='PloneMallCart_label_select_mode',
            description_msgid='PloneMallCart_help_select_mode',
            i18n_domain='plonemallcart',
        ),
        vocabulary=DisplayList((('checkbox','Checkbox'),('numeric','Numeric'),('',''))),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class CartManager(UniqueObject,AllowedTypesByIface,BaseBTreeFolder):
    """
    Cart Manager
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(AllowedTypesByIface,'__implements__',()),) + (getattr(BaseBTreeFolder,'__implements__',()),) + (ICartManager,)


    # This name appears in the 'add' box
    archetype_name             = 'CartManager'

    portal_type = meta_type    = 'CartManager' 
    allowed_content_types      = ['Cart'] 
    allowed_content_interfaces = ['ICart'] 
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'CartManager.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "CartManager"
    typeDescMsgId              = 'description_edit_cartmanager'
    #toolicon                   = 'CartManager.gif'

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        AllowedTypesByIface,BaseBTreeFolder.__init__(self,'portal_cartmanager')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods
    #methods from Interface ICartManager

    security.declareProtected("Buy item", 'getOrCreateCart')
    def getOrCreateCart(self):
        '''
        Return an instance of the registered ICart interface, creating
        the cart at the first time and only returning it after it
        initial creation.
        '''

        sid = self.REQUEST.SESSION.getId()
        cart = self._getOb(sid, None)
        mtool = getToolByName(self, 'portal_membership')
        member = mtool.getAuthenticatedMember()
        if cart is not None and hasattr(member, 'getSessionID'):
            member.setSessionID(sid)
        if cart is None:
            cf = FactoryRegistry.getMallFactory('Cart')
            obj = cf(sid)
            self._setObject(sid, obj)
            cart = getattr(self, sid)
            if hasattr(member, 'getSessionID') and member.getSessionID() is not '':
                old_sid = member.getSessionID()
                old_cart = self._getOb(old_sid, None)
                new_cart = [cart.addItem(obj.getMallItem()) for obj in old_cart.getContents()]
        return cart


    #manually created methods

    def hasFilledCart(self):
        '''
        Return True if a cart exists and cart is not empty.
        '''

        sid = self.REQUEST.SESSION.getId()
        cart = self._getOb(sid, None)
        if cart :
            if cart.getContents() :
                return True
            else:
                return False



registerType(CartManager,PROJECTNAME)
# end of class CartManager

##code-section module-footer #fill in your manual code here
if register_cart:
   FactoryRegistry.registerMallFactory('CartManager', CartManager, (ICartManager,))
##/code-section module-footer



