# File: CustomerInformation.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4.0-beta1 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = ''' <>, Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from Products.PloneMallRegistry.ICustomerInformation import ICustomerInformation


from Products.PloneMallCustomer.config import *
##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    StringField('firstname',
        write_permission='Buy item',
            widget=StringWidget(
    label="First Name",
    label_msgid='PloneMallCustomer_label_firstname',
    description='Enter a value for First Name.',
    description_msgid='PloneMallCustomer_help_firstname',
    i18n_domain='PloneMallCustomer',
)        ,
        required=1    ),
    
    StringField('lastname',
        write_permission='Buy item',
            widget=StringWidget(
    label="Last Name",
    label_msgid='PloneMallCustomer_label_lastname',
    description='Enter a value for Last Name.',
    description_msgid='PloneMallCustomer_help_lastname',
    i18n_domain='PloneMallCustomer',
)        ,
        required=1    ),
    
    StringField('email',
        write_permission='Buy item',
            widget=StringWidget(
    label="Email",
    label_msgid='PloneMallCustomer_label_email',
    description='Enter a value for Email.',
    description_msgid='PloneMallCustomer_help_email',
    i18n_domain='PloneMallCustomer',
)        ,
        required=1    ),
    
    StringField('homePhoneNumber',
        write_permission='Buy item',
        widget=TextAreaWidget(
            label="Phone Numbers",
            label_msgid='PloneMallCustomer_label_phoneNumbers',
            description='Enter a value for Phone Numbers.',
            description_msgid='PloneMallCustomer_help_phoneNumbers',
            i18n_domain='plonemallcustomer',
        ),
    ),

    StringField('company',
            widget=StringWidget(
    label='Company',
    label_msgid='PloneMallCustomer_label_company',
    description='Enter a value for company.',
    description_msgid='PloneMallCustomer_help_company',
    i18n_domain='PloneMallCustomer',
)    ),
    
    StringField('phoneNumbers',
            widget=TextAreaWidget
(
    label="Phone Numbers",
    label_msgid='PloneMallCustomer_label_phoneNumbers',
    description='Enter a value for Phone Numbers.',
    description_msgid='PloneMallCustomer_help_phoneNumbers',
    i18n_domain='PloneMallCustomer',
)    ),

    StringField('EUVATId',
            widget=StringWidget(
    label='Euvatid',
    label_msgid='PloneMallCustomer_label_EUVATId',
    description='Enter a value for EUVATId.',
    description_msgid='PloneMallCustomer_help_EUVATId',
    i18n_domain='PloneMallCustomer',
)    ),

    StringField('fedexNumber',
            widget=StringWidget(
    label='FedEx Number',
    description='Enter a Fed Ex Number.',
    i18n_domain='PloneMallCustomer',
)    ),

    StringField('referredBy',
            widget=StringWidget(
    label='Reffered By',
    description='Enter the name of the referer.',
    i18n_domain='PloneMallCustomer',
)    ),
    
    StringField('comment',
            widget=TextAreaWidget
(
    label='Comment',
    label_msgid='PloneMallCustomer_label_comment',
    description='Enter a value for comment.',
    description_msgid='PloneMallCustomer_help_comment',
    i18n_domain='PloneMallCustomer',
)    ),
    
    ReferenceField('address',
        write_permission='Buy item',
            widget=ReferenceWidget(
    label="Customer Address",
    label_msgid='PloneMallCustomer_label_address',
    description='Enter a value for Customer Address.',
    description_msgid='PloneMallCustomer_help_address',
    i18n_domain='PloneMallCustomer',
)        ,
        allowed_types=('AddressInformationSet',)        ,
        multiValued=0        ,
        relationship='address'    ),    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class CustomerInformation(BaseContent):
    """
    Customer Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (ICustomerInformation,)


    # This name appears in the 'add' box
    archetype_name             = 'CustomerInformation'

    meta_type    = 'CustomerInformation' 
    portal_type  = 'CustomerInformation' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'CustomerInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "CustomerInformation"
    typeDescMsgId              = 'description_edit_customerinformation'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ICustomerInformation

    security.declareProtected("View", 'getCustomerInformationFields')
    def getCustomerInformationFields(self):
        '''
        Return the CustomerInformation archetypes fields list.
        '''
        


registerType(CustomerInformation,PROJECTNAME)
# end of class CustomerInformation

##code-section module-footer #fill in your manual code here
if register_customer_information:
   FactoryRegistry.registerMallFactory('CustomerInformation', CustomerInformation, (ICustomerInformation,))
##/code-section module-footer



