# File: AdvancedItem.py
"""\
Advanced Item

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.ICategorizeable import ICategorizeable



from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    TextField('description',
        widget=TextAreaWidget(
            label="Short Description",
            label_msgid='PloneMallItem_label_description',
            description='Enter a value for Short Description.',
            description_msgid='PloneMallItem_help_description',
            i18n_domain='plonemallitem',
        ),
        accessor="Description",
        searchable="1",
    ),
    
    TextField('full_description',
        widget=TextAreaWidget(
            label="Full Description",
            label_msgid='PloneMallItem_label_full_description',
            description='Enter a value for Full Description.',
            description_msgid='PloneMallItem_help_full_description',
            i18n_domain='plonemallitem',
        ),
        searchable="1",
    ),
    
    ImageField('photo',
        widget=ImageWidget(
            label='Photo',
            label_msgid='PloneMallItem_label_photo',
            description='Enter a value for photo.',
            description_msgid='PloneMallItem_help_photo',
            i18n_domain='plonemallitem',
        ),
        storage=AttributeStorage(),
        sizes={'small':(80,80),'medium':(200,2000),'large':(600,600)},
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class AdvancedItem(BaseFolder):
    """
    Advanced Item
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),) + (ICategorizeable,)


    # This name appears in the 'add' box
    archetype_name             = 'AdvancedItem'

    portal_type = meta_type    = 'AdvancedItem' 
    allowed_content_types      = ['ItemVariant'] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'AdvancedItem.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "AdvancedItem"
    typeDescMsgId              = 'description_edit_advanceditem'

    actions =  (


       {'action':      "string:$object_url/mall_categories",
        'category':    "object",
        'id':          'mall_categories',
        'name':        'categories',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
        

    )

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ICategorizeable

    security.declareProtected("Modify portal content", 'addToCategory')
    def addToCategory(self,category):
        '''
        Add the object to a category.
        '''

        if not FactoryRegistry.objectSupportsInterface(category,ICategorizeable):
            raise TypeError("category %s is not registered as a ICategorizeable implementation" % \
                category.__class__.__name__)

        self.addReference(category, "category")



    security.declareProtected("Modify portal content", 'removeFromCategory')
    def removeFromCategory(self,category):
        '''
        Remove the object from a category.
        '''
        
        self.deleteReference(category, "category")



    security.declareProtected("View", 'listCategories')
    def listCategories(self):
        '''
        List the categories where the object is registered.
        ''' 
        
        return self.getRefs("category")



registerType(AdvancedItem,PROJECTNAME)
# end of class AdvancedItem

##code-section module-footer #fill in your manual code here
if register_advanced_item:
    FactoryRegistry.registerMallFactory('AdvancedItem', AdvancedItem, (ICategorizeable,))
##/code-section module-footer



