# File: BaseItem.py
"""\
Base Item

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.IMallItem import IMallItem



from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.PloneMallRegistry.Currency import Currency, VOC_CURRENCY
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

##/code-section module-header

schema= Schema((
    StringField('currency',
        widget=SelectionWidget
        (
            label='Currency',
            label_msgid='PloneMallItem_label_currency',
            description='Enter a value for currency.',
            description_msgid='PloneMallItem_help_currency',
            i18n_domain='plonemallitem',
        ),
        required=1,
        vocabulary=VOC_CURRENCY,
        default_method="getDefaultCurrency",
    ),
    
    FixedPointField('price',
        default="0.00",
        widget=DecimalWidget(
            label='Price',
            label_msgid='PloneMallItem_label_price',
            description='Enter a value for price.',
            description_msgid='PloneMallItem_help_price',
            i18n_domain='plonemallitem',
        ),
        required=0,
        accessor="Price",
    ),
    
    StringField('sku_code',
        widget=StringWidget(
            label="SKU Code",
            label_msgid='PloneMallItem_label_sku_code',
            description='Enter a value for SKU Code.',
            description_msgid='PloneMallItem_help_sku_code',
            i18n_domain='plonemallitem',
        ),
        required=1,
        searchable="1",
    ),    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BaseItem:
    """
    Base Item
    """
    security = ClassSecurityInfo()
    __implements__ = () + (IMallItem,)


    allowed_content_types      = [] 
    schema = schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface IMallItem

    security.declareProtected("View", 'getPrice')
    def getPrice(self):
        '''
        Return the product price.
        '''

        return Currency(self.getCurrency(), self.Price())



    security.declareProtected("View", 'getSKUCode')
    def getSKUCode(self):
        '''
        Return the product SKU code.

        " The Free On-line Dictionary of Computing (27 SEP 03) "

        SKU

        stock-keeping unit
        '''

        return self.getSku_code()



    security.declareProtected("View", 'isPurchaseableProduct')
    def isPurchaseableProduct(self):
        '''
        Return true if the item is a purchaseable product.
        '''

        reg = getToolByName(self, 'portal_mall_registry')
        return reg.objectSupportsInterface(self, IMallItem)


    #manually created methods

    def getDefaultCurrency(self):
        if hasattr(self,'aq_parent'):
            reg = getToolByName(self, 'portal_mall_registry')
            return reg.getDefaultCurrency()
        else:
            return None


# end of class BaseItem

##code-section module-footer #fill in your manual code here
##/code-section module-footer



