# File: Category.py
"""\
Category

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.ICategorizeable import ICategorizeable
from Products.PloneMallRegistry.ICategory import ICategory



from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.util import filterContents
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    TextField('description',
        widget=TextAreaWidget(
            label="Short Description",
            label_msgid='PloneMallItem_label_description',
            description='Enter a value for Short Description.',
            description_msgid='PloneMallItem_help_description',
            i18n_domain='plonemallitem',
        ),
        accessor="Desciption",
        searchable="1",
    ),
    
    TextField('full_description',
        widget=TextAreaWidget(
            label="Full Description",
            label_msgid='PloneMallItem_label_full_description',
            description='Enter a value for Full Description.',
            description_msgid='PloneMallItem_help_full_description',
            i18n_domain='plonemallitem',
        ),
        searchable="1",
    ),
    
    ImageField('photo',
        widget=ImageWidget(
            label='Photo',
            label_msgid='PloneMallItem_label_photo',
            description='Enter a value for photo.',
            description_msgid='PloneMallItem_help_photo',
            i18n_domain='plonemallitem',
        ),
        storage=AttributeStorage(),
        sizes={'small':(80,80),'medium':(200,2000),'large':(600,600)},
    ),
    
    IntegerField('columns',
        default="2",
        widget=IntegerWidget(
            label='Columns',
            label_msgid='PloneMallItem_label_columns',
            description='Enter a value for columns.',
            description_msgid='PloneMallItem_help_columns',
            i18n_domain='plonemallitem',
        ),
        schemata="PresentationOptions",
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Category(BaseFolder):
    """
    Category
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),) + (ICategorizeable,ICategory,)


    # This name appears in the 'add' box
    archetype_name             = 'Category'

    portal_type = meta_type    = 'Category' 
    allowed_content_types      = [] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'Category.gif'
    immediate_view             = 'category_view'
    default_view               = 'category_view'
    typeDescription            = "Category"
    typeDescMsgId              = 'description_edit_category'

    actions =  (


       {'action':      "string:$object_url/mall_categories",
        'category':    "object",
        'id':          'mall_categories',
        'name':        'categories',
        'permissions': ("Modify portal content",),
        'condition'  : 'python:1',
        'visible':False,
       },
       
       {'id':'view',
        'action':"string:$object_url/noedit_view",
       },
       
       {'action':'string:${object_url}/folder_localrole_form',
        'id':"local_roles",
        'name':'Sharing',
        'permissions':('Manage properties',),
        'category':'object',
       }
        

    )

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ICategorizeable

    security.declareProtected("Modify portal content", 'addToCategory')
    def addToCategory(self,category):
        '''
        Add the object to a category.
        '''

        if not FactoryRegistry.objectSupportsInterface(category,ICategorizeable):
            raise TypeError("category %s is not registered as a ICategorizeable implementation" % \
                category.__class__.__name__)
                
        self.addReference(category, "category")



    security.declareProtected("Modify portal content", 'removeFromCategory')
    def removeFromCategory(self,category):
        '''
        Remove the object from a category.
        '''
        
        self.deleteReference(category, "category")



    security.declareProtected("View", 'listCategories')
    def listCategories(self):
        '''
        List the categories where the object is registered.
        '''
        
        return self.getRefs("category")


    #methods from Interface ICategory

    security.declareProtected("View", 'getContents')
    def getContents(self, filter = {}):
        '''
        Return a list of objects that are registered inside the category. The
        result could be filtered using a dictionary, where the keys are object
        properties and the values are acceptable values for these keys.
        '''

        return filterContents(self.getBRefs("category"), filter)


    #manually created methods

    def getShort_description(self):
        ''' for backward compatibility'''
        return self.Description()
        
    def getCategoryOwners(self):
        roles = dict(self.get_local_roles())
        return roles.keys()



registerType(Category,PROJECTNAME)
# end of class Category

##code-section module-footer #fill in your manual code here
if register_category:
   FactoryRegistry.registerMallFactory('Category', Category, (ICategory, ICategorizeable))
##/code-section module-footer



