# File: ItemVariant.py
"""\
Item Variant

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from BaseItem import BaseItem



from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.IMallItem import IMallItem
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    LinesField('units',
        widget=LinesWidget(
            label='Units',
            label_msgid='PloneMallItem_label_units',
            description='Enter a value for units.',
            description_msgid='PloneMallItem_help_units',
            i18n_domain='plonemallitem',
        ),
        required=1,
    ),
    
    LinesField('values',
        widget=LinesWidget(
            label='Values',
            label_msgid='PloneMallItem_label_values',
            description='Enter a value for values.',
            description_msgid='PloneMallItem_help_values',
            i18n_domain='plonemallitem',
        ),
        required=1,
    ),
    
    FixedPointField('handling',
        accessor='''Handling''',
        default='''0.00''',
        required=0,
        widget=DecimalWidget(description='Enter a value for handling.',
            description_msgid='PloneMallItem_help_handling',
            i18n_domain='PloneMallItem',
            label='Handling',
            label_msgid='PloneMallItem_label_handling',
        ),
    ),
    
    FixedPointField('weight',
        accessor='''Weight''',
        precision=1,
        default='''0.0''',
        required=1,
        widget=DecimalWidget(description='Enter a value for weight in LBS.',
            description_msgid='PloneMallItem_help_weight',
            i18n_domain='PloneMallItem',
            label='Weight',
            label_msgid='PloneMallItem_label_weight',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ItemVariant(BaseItem,BaseContent):
    """
    Item Variant
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseItem,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'ItemVariant'

    portal_type = meta_type    = 'ItemVariant' 
    allowed_content_types      = [] + list(getattr(BaseItem,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'ItemVariant.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "ItemVariant"
    typeDescMsgId              = 'description_edit_itemvariant'

    actions =  (


       {'action':      "string:$object_url/itemvariant_view",
        'category':    "object",
        'id':          'view',
        'name':        'view',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
        

    )

    schema = BaseSchema + \
             getattr(BaseItem,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    def getShort_description(self):
        '''
        Return the short description. This method is just an alias to
        the same method in the AdvancedItem class. It is important
        only to avoid problems on UI and make things easier.
        '''

        return self.aq_parent.getShort_description()



registerType(ItemVariant,PROJECTNAME)
# end of class ItemVariant

##code-section module-footer #fill in your manual code here
if register_advanced_item: 
   FactoryRegistry.registerMallFactory('ItemVariant', ItemVariant, (IMallItem,))
##/code-section module-footer



