# File: MailOrder.py
"""\
unknown

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneFormMailer.PloneFormMailer import PloneFormMailer



from Products.PloneMallOrder.config import *

##code-section module-header #fill in your manual code here
from config import default_mailtemplate_body
##/code-section module-header

schema= Schema((
    StringField('subjectcustomer',
        widget=StringWidget(
            label="Subject Customer",
            label_msgid='PloneMallOrder_label_subjectcustomer',
            description='Enter a value for Subject Customer.',
            description_msgid='PloneMallOrder_help_subjectcustomer',
            i18n_domain='plonemallorder',
        ),
        schemata="Mail Order",
    ),
    
    LinesField('hidefields',
        widget=LinesWidget(
            label="Hide Fields",
            label_msgid='PloneMallOrder_label_hidefields',
            description='Enter a value for Hide Fields.',
            description_msgid='PloneMallOrder_help_hidefields',
            i18n_domain='plonemallorder',
        ),
        schemata="Mail Order",
    ),
    
    TextField('body_pt',
        mutator="setBodyPT",
        widget=TextAreaWidget(
            description="Template for mail body",
            rows=30,
            label="Mail Body Template",
            label_msgid='PloneMallOrder_label_body_pt',
            description_msgid='PloneMallOrder_help_body_pt',
            i18n_domain='plonemallorder',
        ),
        schemata="Template",
        validators=('zptvalidator',),
        default=default_mailtemplate_body,
        default_content_type="application/xml+xhtml",
        default_output_type="text/plain",
        accessor="getBodyPT",
    ),
    
    TextField('body_footer',
        default="Sent by PloneMall",
        widget=TextAreaWidget(
            description="Footer line, appears under a dashed line",
            label="Footer",
            label_msgid='PloneMallOrder_label_body_footer',
            description_msgid='PloneMallOrder_help_body_footer',
            i18n_domain='plonemallorder',
        ),
        schemata="Mail Message",
    ),
    
    BooleanField('mail_to_customer',
        default=1,
        widget=BooleanWidget(
            description="specifies wether aafter an order a mail should be sent to the customer",
            label='Mail_to_customer',
            label_msgid='PloneMallOrder_label_mail_to_customer',
            description_msgid='PloneMallOrder_help_mail_to_customer',
            i18n_domain='plonemallorder',
        ),
    ),
    
    BooleanField('mail_to_merchant',
        default=1,
        widget=BooleanWidget(
            description="should a mail be sent to the merchant?",
            label='Mail_to_merchant',
            label_msgid='PloneMallOrder_label_mail_to_merchant',
            description_msgid='PloneMallOrder_help_mail_to_merchant',
            i18n_domain='plonemallorder',
        ),
    ),
    
    StringField('subject',
        mutator="setSubject",
        widget=StringWidget(
            description="Subject line of message.TALES Expression. If you don\'t know TALES expressions just enter string:YOURTEXT",
            label='Subject',
            label_msgid='PloneMallOrder_label_subject',
            description_msgid='PloneMallOrder_help_subject',
            i18n_domain='plonemallorder',
        ),
        schemata="Mail Message",
        validators=('talesvalidator',),
        default=default_mailorder_subject,
        accessor="getSubject",
        label="Subject",
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class MailOrder(PloneFormMailer,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(PloneFormMailer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'MailOrder'

    portal_type = meta_type    = 'MailOrder' 
    allowed_content_types      = [] + list(getattr(PloneFormMailer,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'MailOrder.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "MailOrder"
    typeDescMsgId              = 'description_edit_mailorder'

    schema = BaseSchema + \
             getattr(PloneFormMailer,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    def initializeArchetype(self):
        ''' '''
        self.update(body_pt=self.getBodyPT())


    def send_form(self,order,*a,**kw):
        if not (self.getMail_to_merchant() or self.getMail_to_customer()):
            return
        
        cust=order.getCustomer()
        fullname="%s %s" % (cust.getFirstname(),cust.getLastname())
        
        cust_email=cust.getEmail()
        vend_email=self.getRecipientEmail()
        
        if self.getMail_to_merchant():
            PloneFormMailer.send_form(self,order=order,fullname=fullname,from_addr=cust_email,*a,**kw)

        if self.getMail_to_customer():
            PloneFormMailer.send_form(self,order=order,fullname=fullname,from_addr=vend_email,to_addr=cust_email,*a,**kw)


    def __init__(self,*a,**kw):
        PloneFormMailer.__init__(self,*a,**kw)



registerType(MailOrder,PROJECTNAME)
# end of class MailOrder

##code-section module-footer #fill in your manual code here
##/code-section module-footer



