# File: Order.py
"""\
Order

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.IOrder import IOrder



from Products.PloneMallOrder.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.Currency import Currency
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.ICustomerInformation import ICustomerInformation
from Products.PloneMallRegistry.IAddressInformation  import IAddressInformation
from Products.PloneMallRegistry.ICart                import ICart
from Products.PloneMallRegistry.ICartItem            import ICartItem
from Products.PloneMallRegistry.IShippingInformation import IShippingInformation
from Products.PloneMallRegistry.IPaymentInformation  import IPaymentInformation
from Products.PloneMallRegistry.ITaxInformation      import ITaxInformation
from Products.PloneMallRegistry.ITaxInformationSet   import ITaxInformationSet
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    ReferenceField('order_customer',
        widget=ReferenceWidget(
            label="Customer",
            label_msgid='PloneMallOrder_label_order_customer',
            description='Enter a value for Customer.',
            description_msgid='PloneMallOrder_help_order_customer',
            i18n_domain='plonemallorder',
        ),
        required=1,
        relationship="customer",
        allowed_types=('CustomerInformation',),
    ),
    
    ReferenceField('order_customer_address',
        widget=ReferenceWidget(
            label="Customer Address",
            label_msgid='PloneMallOrder_label_order_customer_address',
            description='Enter a value for Customer Address.',
            description_msgid='PloneMallOrder_help_order_customer_address',
            i18n_domain='plonemallorder',
        ),
        required=1,
        relationship="customer_address",
        allowed_types=('AddressInformation',),
    ),
    
    ReferenceField('order_cart',
        widget=ReferenceWidget(
            label="Cart",
            label_msgid='PloneMallOrder_label_order_cart',
            description='Enter a value for Cart.',
            description_msgid='PloneMallOrder_help_order_cart',
            i18n_domain='plonemallorder',
        ),
        required=1,
        relationship="cart",
        allowed_types=('Cart',),
    ),
    
    BooleanField('has_shipping',
        widget=BooleanWidget(
            label="This order has shipping?",
            description="For some business models, shipping information is useless.",
            label_msgid='PloneMallOrder_label_has_shipping',
            description_msgid='PloneMallOrder_help_has_shipping',
            i18n_domain='plonemallorder',
        ),
        required=1,
    ),
    
    ReferenceField('order_shipping',
        widget=ReferenceWidget(
            label="Shipping",
            label_msgid='PloneMallOrder_label_order_shipping',
            description='Enter a value for Shipping.',
            description_msgid='PloneMallOrder_help_order_shipping',
            i18n_domain='plonemallorder',
        ),
        required=0,
        relationship="shipping",
        allowed_types=('ShippingInformation',),
    ),
    
    ReferenceField('order_shipping_address',
        widget=ReferenceWidget(
            label="Shipping Address",
            label_msgid='PloneMallOrder_label_order_shipping_address',
            description='Enter a value for Shipping Address.',
            description_msgid='PloneMallOrder_help_order_shipping_address',
            i18n_domain='plonemallorder',
        ),
        required=0,
        relationship="shipping_address",
        allowed_types=('AddressInformation',),
    ),
    
    BooleanField('has_shipping_address_by_item',
        widget=BooleanWidget(
            label="This order has different shipping addresses for each cart item?",
            description="This feature must be suported by your shipping method implementation.",
            label_msgid='PloneMallOrder_label_has_shipping_address_by_item',
            description_msgid='PloneMallOrder_help_has_shipping_address_by_item',
            i18n_domain='plonemallorder',
        ),
        required=1,
    ),
    
    BooleanField('has_payment',
        widget=BooleanWidget(
            label="This order has payment?",
            description="For some business models, payment information are useless.",
            label_msgid='PloneMallOrder_label_has_payment',
            description_msgid='PloneMallOrder_help_has_payment',
            i18n_domain='plonemallorder',
        ),
        required=1,
    ),
    
    ReferenceField('order_payment',
        widget=ReferenceWidget(
            label="Payment",
            label_msgid='PloneMallOrder_label_order_payment',
            description='Enter a value for Payment.',
            description_msgid='PloneMallOrder_help_order_payment',
            i18n_domain='plonemallorder',
        ),
        required=0,
        relationship="payment",
        allowed_types=('PaymentInformation',),
    ),
    
    ReferenceField('order_payment_address',
        widget=ReferenceWidget(
            label="Payment Address",
            label_msgid='PloneMallOrder_label_order_payment_address',
            description='Enter a value for Payment Address.',
            description_msgid='PloneMallOrder_help_order_payment_address',
            i18n_domain='plonemallorder',
        ),
        required=0,
        relationship="payment_address",
        allowed_types=('AddressInformation',),
    ),
    
    BooleanField('has_tax',
        widget=BooleanWidget(
            label="This order has tax?",
            description="For some business models, tax information is useless.",
            label_msgid='PloneMallOrder_label_has_tax',
            description_msgid='PloneMallOrder_help_has_tax',
            i18n_domain='plonemallorder',
        ),
        required=1,
    ),
    
    ReferenceField('order_tax',
        widget=ReferenceWidget(
            label="Tax",
            label_msgid='PloneMallOrder_label_order_tax',
            description='Enter a value for Tax.',
            description_msgid='PloneMallOrder_help_order_tax',
            i18n_domain='plonemallorder',
        ),
        required=0,
        relationship="tax",
        allowed_types=('TaxInformationSet',),
    ),
    
    BooleanField('has_tax_by_item',
        widget=BooleanWidget(
            label="This order has different tax for each cart item?",
            description="This feature must be suported by your tax method implementation.",
            label_msgid='PloneMallOrder_label_has_tax_by_item',
            description_msgid='PloneMallOrder_help_has_tax_by_item',
            i18n_domain='plonemallorder',
        ),
        required=1,
    ),

    FixedPointField('discount',
        widget=DecimalWidget(
            label="The discount",
            i18n_domain='plonemallorder',
        ),
    ),

),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Order(BaseFolder):
    """
    Order
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),) + (IOrder,)


    # This name appears in the 'add' box
    archetype_name             = 'Order'

    portal_type = meta_type    = 'Order' 
    allowed_content_types      = ['Cart', 'ShippingInformation', 'PaymentInformation', 'TaxInformationSet'] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'Order.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "Order"
    typeDescMsgId              = 'description_edit_order'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    def getOrder(self):
        return self
    
    security.declarePublic('getOrderId')
    def getOrderId(self):
        """
        
        """
        
        return self.getId()

    def getOrderNumber(self):
        return self.Title() or self.getId()
    
    #methods from Interface IOrder

    security.declareProtected("View", 'getCustomer')
    def getCustomer(self):
        '''
        Return the customer.
        '''

        try:
            return self.getRefs('customer')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setCustomer')
    def setCustomer(self,customer):
        '''
        Set the customer.
        '''

        if not FactoryRegistry.objectSupportsInterface(customer,ICustomerInformation):
            raise TypeError("customer %s is not registered as a ICustomerInformation implementation" % \
                customer.__class__.__name__)

        self.deleteReferences('customer')
        self.addReference(customer, 'customer')



    security.declareProtected("View", 'getCustomerAddress')
    def getCustomerAddress(self):
        '''
        Return the customer address.
        '''

        try:
            return self.getRefs('customer_address')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setCustomerAddress')
    def setCustomerAddress(self,customer_address):
        '''
        Set the customer address.
        '''

        if not FactoryRegistry.objectSupportsInterface(customer_address,IAddressInformation):
            raise TypeError("customer address %s is not registered as a IAddressInformation implementation" % \
                customer_address.__class__.__name__)

        self.deleteReferences('customer_address')
        self.addReference(customer_address, 'customer_address')



    security.declareProtected("View", 'getCart')
    def getCart(self):
        '''
        Return the order cart.
        '''

        try:
            return self.getRefs('cart')[0]
        except IndexError:
            return None


    security.declareProtected("View", "getHandling")
    def getHandling(self):
        '''
        Return the handling
        '''
        cart = self.getCart()
        ret = Currency()
        
        ret += cart.getHandling()
        
        #if cart.hasOrderShipping:
        #    ret += order.getOrderHandling()
            
        return ret

    def getWeight(self):
        '''
        Return the handling
        '''
        
        cart = self.getCart()
        return cart.getWeight()

    security.declareProtected("Modify portal content", 'setCart')
    def setCart(self,cart):
        '''
        Set the order cart. Here, a good approach is move the cart from
        the CartManager to inside the Order. It would avoid possible
        problems with session ids conflicts and will turn the
        persistence model more elegant. It's not mandatory, duo the
        placeless design of the interface, but It's a good practice:
        keep everything about an Order inside itself.
        '''

        if not FactoryRegistry.objectSupportsInterface(cart,ICart):
            raise TypeError("cart %s is not registered as a ICart implementation" % \
                cart.__class__.__name__)

        self.deleteReferences('cart')
        self.addReference(cart, 'cart')

        self._enforceStore(cart)



    security.declareProtected("View", 'hasShipping')
    def hasShipping(self):
        '''
        Return true if the order has shipping. In some business models,
        shipping information is useless (e.g. a service provider that
        sell hosting plan or a theater that sells tickets).
        '''
        
        return self.getHas_shipping()



    security.declareProtected("View", 'getShipping')
    def getShipping(self):
        '''
        Return the shipping.
        '''

        try:
            return self.getRefs('shipping')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setShipping')
    def setShipping(self,shipping):
        '''
        Set the shipping.
        '''

        if not FactoryRegistry.objectSupportsInterface(shipping,IShippingInformation):
            raise TypeError("shipping %s is not registered as a IShippingInformation implementation" % \
                shipping.__class__.__name__)

        self.deleteReferences('shipping')
        self.addReference(shipping, 'shipping')

        self._enforceStore(shipping)



    security.declareProtected("View", 'getShippingAddress')
    def getShippingAddress(self):
        '''
        Return the general shipping address.
        '''

        try:
            return self.getRefs('shipping_address')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setShippingAddress')
    def setShippingAddress(self,shipping_address):
        '''
        Set the general shipping address.
        '''

        if not FactoryRegistry.objectSupportsInterface(shipping_address,IAddressInformation):
            raise TypeError("shipping address %s is not registered as a IAddressInformation implementation" % \
                shipping_address.__class__.__name__)

        self.deleteReferences('shipping_address')
        self.addReference(shipping_address, 'shipping_address')



    security.declareProtected("View", 'hasShippingAddressByItem')
    def hasShippingAddressByItem(self):
        '''
        Return true if the order has different shipping addresses for
        each cart item.
        '''
        
        return self.getHas_shipping_address()



    security.declareProtected("View", 'getShippingAddressByItem')
    def getShippingAddressByItem(self,item):
        '''
        Return the shipping address for the cart item.
        '''

        try:
            return item.getRefs('shipping_address')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setShippingAddressByItem')
    def setShippingAddressByItem(self,item,shipping_address):
        '''
        Set the shipping address for the cart item.
        '''

        if not FactoryRegistry.objectSupportsInterface(Item,ICartItem):
            raise TypeError("item %s is not registered as a ICartItem implementation" % \
                item.__class__.__name__)

        if not FactoryRegistry.objectSupportsInterface(shipping_address,IAddressInformation):
            raise TypeError("shipping address %s is not registered as a IAddressInformation implementation" % \
                shipping_address.__class__.__name__)

        item.deleteReferences('shipping_address')
        item.addReference(shipping_address, 'shipping_address')



    security.declareProtected("View", 'hasPayment')
    def hasPayment(self):
        '''
        Return true if the order has payment. Could appears strange, but
        in some business models, payment information would be useless
        (e.g. a theater that does tickets reservations instead of really
        sell it by internet; you pay when you get the ticket at the
        movies)
        '''
        
        return self.getHas_payment()



    security.declareProtected("View", 'getPayment')
    def getPayment(self):
        '''
        Return the payment.
        '''

        try:
            return self.getRefs('payment')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setPayment')
    def setPayment(self,payment):
        '''
        Set the payment.
        '''

        if not FactoryRegistry.objectSupportsInterface(payment,IPaymentInformation):
            raise TypeError("payment %s is not registered as a IPaymentInformation implementation" % \
                payment.__class__.__name__)

        self.deleteReferences('payment')
        self.addReference(payment, 'payment')

        self._enforceStore(payment)



    security.declareProtected("View", 'getPaymentAddress')
    def getPaymentAddress(self):
        '''
        Return the payment address.
        '''

        try:
            return self.getRefs('payment_address')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setPaymentAddress')
    def setPaymentAddress(self,payment_address):
        '''
        Set the payment address.
        '''

        if not FactoryRegistry.objectSupportsInterface(payment_address,IAddressInformation):
            raise TypeError("payment_address %s is not registered as a IAddressInformation implementation" % \
                payment_address.__class__.__name__)

        self.deleteReferences('payment_address')
        self.addReference(payment_address, 'payment_address')



    security.declareProtected("View", 'hasTax')
    def hasTax(self):
        '''
        Return true if the order has tax. Nowdays, It is a bit hard to
        find a business model that does not need to pay taxes, but a
        good example where payment information is useless are bookstores
        (that does not pay taxes because books are cultural stuff).
        '''
        
        return self.getHas_tax()

    security.declareProtected("View", 'hasTaxByItem')
    def hasTaxByItem(self):
        '''
        Return true if the order has tax by item.
        '''
        
        return self.getHas_tax_by_item()

    security.declareProtected("View", 'getTax')
    def getTax(self):
        '''
        Return the tax.
        '''

        try:
            return self.getRefs('tax')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setTax')
    def setTax(self,tax):
        '''
        Set the tax.
        '''

        if not FactoryRegistry.objectSupportsInterface(tax,ITaxInformationSet):
            raise TypeError("tax %s is not registered as a ITaxInformation implementation" % \
                tax.__class__.__name__)

        self.deleteReferences('tax')
        self.addReference(tax, 'tax')

        self._enforceStore(tax)



    security.declareProtected("View", 'hasTaxByItem')
    def hasTaxByItem(self):
        '''
        Return true if the order has different taxes for each cart item.
        '''
        
        return self.getHas_tax_by_item()



    security.declareProtected("View", 'getTaxByItem')
    def getTaxByItem(self,item):
        '''
        Return the tax for the cart item.
        '''

        try:
            return item.getRefs('tax')[0]
        except IndexError:
            return None



    security.declareProtected("Modify portal content", 'setTaxByItem')
    def setTaxByItem(self,item,tax):
        '''
        Set the tax for the cart item.
        '''
        if not FactoryRegistry.objectSupportsInterface(item,ICarttem):
            raise TypeError("item %s is not registered as a ICartItem implementation" % \
                item.__class__.__name__)

        if not FactoryRegistry.objectSupportsInterface(tax,ITaxInformation):
            raise TypeError("tax %s is not registered as a ITaxInformation implementation" % \
                tax.__class__.__name__)

        item.deleteReferences('tax')
        item.addReference(tax, 'tax')

    def getNetTotal(self):
        cart = self.getCart()
        if cart is not None:
            return cart.getTotal()

    def getShippingTotal(self):
        if self.hasShipping():
            shipping = self.getShipping()
            if shipping is not None:
                return shipping.getShippingTotal()
            
    def getPaymentTotal(self):
        if self.hasPayment():
            payment = self.getPayment()
            if payment is not None:
                return payment.getPaymentTotal()
        
    def getTaxTotal(self):
            tax = self.getTax()
            if tax is not None:
                return tax.getTaxTotal({'isIncludedInPrice' : 0})

    security.declareProtected("View", 'getTotal')
    def getTotal(self):
        '''
        Return the order total.
        '''
        
        total = Currency()
        
        total += self.getNetTotal()

        # subtract the discount
        discount = float(self.getDiscount())
        if  discount > 0.0:
            new_total = float(total.getValue()) - discount
            if new_total < 0.0:
                self.setDiscount(total.getValue())
                total = Currency()
            else:
                total = Currency(currency='USD', value=new_total)

        if self.hasShipping():
            shipping = self.getShipping()
            if shipping is not None:
                total += shipping.getShippingTotal()

        if self.hasTax():
            tax = self.getTax()
            if tax is not None:
                total += tax.getTaxTotal({'isIncludedInPrice' : 0})
        
        return total
    
    #manually created methods
    def _enforceStore(self, obj1, iface = None, obj2 = None):
        # TODO: Cart needs a clone method to play nice with security
        # and with reference engine
        return None

        if iface is None: iface = IOrder
        if obj2 is None: obj2 = self
        p = obj1.aq_parent
        if not FactoryRegistry.objectSupportsInterface(p,iface):
            cb = p.manage_cutObjects([obj1.getId()])
            obj2.manage_pasteObjects(cb)


    def notifyEmail(self):
        om=self.aq_parent
        if hasattr(om,'mailorder'):
            om.mailorder.send_form(order=self)
        elif hasattr(om,'portal_merkurorderemissions'):
            emissions=om.portal_merkurorderemissions
            for emission in emissions.contentValues():
                emission.sendSingleMail(self.UID())



registerType(Order,PROJECTNAME)
# end of class Order

##code-section module-footer #fill in your manual code here
if register_order:
    FactoryRegistry.registerMallFactory('Order', Order, (IOrder,))
##/code-section module-footer



