## Script (Python) "checkout"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
from Products.PloneMallOrder.exceptions import EmptyCart, \
                                               MissingCustomer, \
                                               MissingCustomerAddress, \
                                               MissingShippingMethod, \
                                               MissingPaymentMethod, \
                                               MissingTaxMethod, \
                                               MissingOrderConfirmation

r = context.REQUEST
s = r.SESSION

pom = context.portal_ordermanager

cart = context.portal_cartmanager.getOrCreateCart()
order_with_shipping = True
if not cart.getWeight():
    order_with_shipping = False
    s['shipping_method'] = 'FedEx'
s['order_with_shipping'] = order_with_shipping

try:
  order_id = pom.addOrder()
except (EmptyCart,):
  return r.RESPONSE.redirect(context.absolute_url() + '/empty_cart')
except (MissingCustomer, MissingCustomerAddress):
  return r.RESPONSE.redirect(context.absolute_url() + '/customer')
except MissingShippingMethod:
  return r.RESPONSE.redirect(context.absolute_url() + '/shipping')
except MissingPaymentMethod:
  return r.RESPONSE.redirect(context.absolute_url() + '/payment')
except MissingTaxMethod:
  return r.RESPONSE.redirect(context.absolute_url() + '/Tax_redirect')
except MissingOrderConfirmation:
  return r.RESPONSE.redirect(context.absolute_url() + '/order_review')

# Now, we set the Order id as a SESSION variable.  Try to not use the
# SESSION variables (customer, customer_address, shipping_method,
# payment_method and tax_method) after this point, but the
# portal_ordermanager API.

# so, let's invalidate the SESSION
# so hey let's only invalidate PM sessions not everything - claytron
s.invalidate()
s=context.session_data_manager.getSessionData()

# and... create a new SESSION
s['order_id'] = order_id
order=pom.getOrderById(order_id)

s['order_with_shipping'] = order_with_shipping

if order.hasPayment():
    res=order.getPayment().processPayment()
else:
    return context.REQUEST.RESPONSE.redirect('%s/thankyou?order_id=%s' % \
                                           (context.portal_url(), order_id))
