""" Workflow: plonemall_payment_workflow
"""

# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
#
# Generator: ArchGenXML Version 1.4 devel 2
#            http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__    = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'
__version__   = '$ Revision 0.0 $'[11:-2]

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallPayment'

def setupplonemall_payment_workflow(self, wf):
    """
    plonemall_payment_workflow Workflow Definition
    """

    wf.setProperties(title='plonemall_payment_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    # generation of worklists is not defined yet...
    ### XXX :-(

    for s in ['uninitialized', 'initialized', 'validation', 'validated', 'processing', 'sucessful', 'failure', 'aborted']:
        wf.states.addState(s)

    for t in ['doProcessing', 'abort', 'startProcessing', 'initialize', 'retryProcessing', 'validate', 'validationFail', 'processFail', 'validationSucceed']:
        wf.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        wf.variables.addVariable(v)

    for p in []:
        wf.addManagedPermission(p)

    ## Initial State

    wf.states.setInitialState('uninitialized')

    ## States initialization

    sdef = wf.states['uninitialized']
    sdef.setProperties(title="""uninitialized""",
                       transitions=['initialize', 'abort'])

    sdef = wf.states['initialized']
    sdef.setProperties(title="""initialized""",
                       transitions=['validate', 'abort'])

    sdef = wf.states['validation']
    sdef.setProperties(title="""validation""",
                       transitions=['validationFail', 'validationSucceed'])

    sdef = wf.states['validated']
    sdef.setProperties(title="""validated""",
                       transitions=['startProcessing'])

    sdef = wf.states['processing']
    sdef.setProperties(title="""processing""",
                       transitions=['doProcessing', 'processFail'])

    sdef = wf.states['sucessful']
    sdef.setProperties(title="""sucessful""",
                       transitions=[])

    sdef = wf.states['failure']
    sdef.setProperties(title="""failure""",
                       transitions=['retryProcessing'])

    sdef = wf.states['aborted']
    sdef.setProperties(title="""aborted""",
                       transitions=[])

    ## Transitions initialization
        
    tdef = wf.transitions['doProcessing']
    tdef.setProperties(title="""doProcessing""",
                       new_state_id="""sucessful""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""doProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['abort']
    tdef.setProperties(title="""abort""",
                       new_state_id="""aborted""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""abort""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['startProcessing']
    tdef.setProperties(title="""startProcessing""",
                       new_state_id="""processing""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""startProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['initialize']
    tdef.setProperties(title="""initialize""",
                       new_state_id="""initialized""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""initialize""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['retryProcessing']
    tdef.setProperties(title="""retryProcessing""",
                       new_state_id="""uninitialized""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""retryProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['validate']
    tdef.setProperties(title="""validate""",
                       new_state_id="""validation""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""validate""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['validationFail']
    tdef.setProperties(title="""validationFail""",
                       new_state_id="""failure""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""validationFail""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['processFail']
    tdef.setProperties(title="""processFail""",
                       new_state_id="""failure""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""processFail""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['validationSucceed']
    tdef.setProperties(title="""validationSucceed""",
                       new_state_id="""validated""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""validationSucceed""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    # XXX Generation of worklists is not implemented yet...
    # in the meantime, you can use the protected code section below to
    # do it manually

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer


def createplonemall_payment_workflow(self, id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupplonemall_payment_workflow(self, ob)
    return ob

addWorkflowFactory(createplonemall_payment_workflow,
                   id='plonemall_payment_workflow',
                   title='plonemall_payment_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

