""" Workflow: plonemall_redirecting_payment_workflow
"""

# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
#
# Generator: ArchGenXML Version 1.4 devel 2
#            http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__    = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'
__version__   = '$ Revision 0.0 $'[11:-2]

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallPayment'

def setupplonemall_redirecting_payment_workflow(self, wf):
    """
    plonemall_redirecting_payment_workflow Workflow Definition
    """

    wf.setProperties(title='plonemall_redirecting_payment_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    # generation of worklists is not defined yet...
    ### XXX :-(

    for s in ['processing', 'success', 'failed', 'confirmed', 'initialized', 'cancelled', 'created', 'aborted']:
        wf.states.addState(s)

    for t in ['successProcessing', 'failureProcessing', 'abort', 'startProcessing', 'cancelProcessing', 'initializeProcessing']:
        wf.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        wf.variables.addVariable(v)

    for p in []:
        wf.addManagedPermission(p)

    ## Initial State

    wf.states.setInitialState('created')

    ## States initialization

    sdef = wf.states['processing']
    sdef.setProperties(title="""processing""",
                       transitions=['cancelProcessing', 'successProcessing', 'failureProcessing'])

    sdef = wf.states['success']
    sdef.setProperties(title="""success""",
                       transitions=[])

    sdef = wf.states['failed']
    sdef.setProperties(title="""failed""",
                       transitions=[])

    sdef = wf.states['confirmed']
    sdef.setProperties(title="""confirmed""",
                       transitions=[])

    sdef = wf.states['initialized']
    sdef.setProperties(title="""initialized""",
                       transitions=['startProcessing'])

    sdef = wf.states['cancelled']
    sdef.setProperties(title="""cancelled""",
                       transitions=[])

    sdef = wf.states['created']
    sdef.setProperties(title="""created""",
                       transitions=['abort', 'initializeProcessing'])

    sdef = wf.states['aborted']
    sdef.setProperties(title="""aborted""",
                       transitions=[])

    ## Transitions initialization
        
    ##creation of workflow scripts
    for wf_scriptname in ['onSuccessProcessing']:
        if not wf_scriptname in wf.scripts.objectIds():
            wf.scripts._setObject(wf_scriptname,ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))
    
    tdef = wf.transitions['successProcessing']
    tdef.setProperties(title="""successProcessing""",
                       new_state_id="""success""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""onSuccessProcessing""",
                       actbox_name="""successProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    ##creation of workflow scripts
    for wf_scriptname in ['onFailProcessing']:
        if not wf_scriptname in wf.scripts.objectIds():
            wf.scripts._setObject(wf_scriptname,ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))
    
    tdef = wf.transitions['failureProcessing']
    tdef.setProperties(title="""failureProcessing""",
                       new_state_id="""failed""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""onFailProcessing""",
                       actbox_name="""failureProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['abort']
    tdef.setProperties(title="""abort""",
                       new_state_id="""aborted""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""abort""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    ##creation of workflow scripts
    for wf_scriptname in ['onStartProcessing']:
        if not wf_scriptname in wf.scripts.objectIds():
            wf.scripts._setObject(wf_scriptname,ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))
    
    tdef = wf.transitions['startProcessing']
    tdef.setProperties(title="""startProcessing""",
                       new_state_id="""processing""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""onStartProcessing""",
                       actbox_name="""startProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    ##creation of workflow scripts
    for wf_scriptname in ['onAbort']:
        if not wf_scriptname in wf.scripts.objectIds():
            wf.scripts._setObject(wf_scriptname,ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))
    
    tdef = wf.transitions['cancelProcessing']
    tdef.setProperties(title="""cancelProcessing""",
                       new_state_id="""cancelled""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""onAbort""",
                       actbox_name="""cancelProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )
        
    tdef = wf.transitions['initializeProcessing']
    tdef.setProperties(title="""initializeProcessing""",
                       new_state_id="""initialized""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""initializeProcessing""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    # XXX Generation of worklists is not implemented yet...
    # in the meantime, you can use the protected code section below to
    # do it manually

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer


def createplonemall_redirecting_payment_workflow(self, id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupplonemall_redirecting_payment_workflow(self, ob)
    return ob

addWorkflowFactory(createplonemall_redirecting_payment_workflow,
                   id='plonemall_redirecting_payment_workflow',
                   title='plonemall_redirecting_payment_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

