# File: PayPalSettings.py
"""\
PayPal Settings

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from RedirectingPaymentSettings import RedirectingPaymentSettings
from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings


from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

##/code-section module-header

schema= Schema((
    ComputedField('business',
        widget=ComputedWidget(
            label='Business',
            label_msgid='PloneMallPayment_label_business',
            description='Enter a value for business.',
            description_msgid='PloneMallPayment_help_business',
            i18n_domain='plonemallpayment',
        ),
        expression="context.getMerchantkey()",
    ),
    
    StringField('baseUrl',
        default="https://www.paypal.com/cgi-bin/webscr",
        widget=StringWidget(
            label="Base URL",
            label_msgid='PloneMallPayment_label_baseUrl',
            description='Enter a value for Base URL.',
            description_msgid='PloneMallPayment_help_baseUrl',
            i18n_domain='plonemallpayment',
        ),
    ),
    
    StringField('payment_method',
        default='paypal',
        widget=StringWidget(
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            description='Enter a value for payment_method.',
            description_msgid='PloneMallPayment_help_payment_method',
            i18n_domain='plonemallpayment',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PayPalSettings(RedirectingPaymentSettings,BaseContent):
    """
    PayPal Settings
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(RedirectingPaymentSettings,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),) + (IPaymentSettings,)


    # This name appears in the 'add' box
    archetype_name             = 'PayPalSettings'

    portal_type = meta_type    = 'PayPalSettings' 
    allowed_content_types      = [] + list(getattr(RedirectingPaymentSettings,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'PayPalSettings.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "PayPalSettings"
    typeDescMsgId              = 'description_edit_paypalsettings'

    schema = BaseSchema + \
             getattr(RedirectingPaymentSettings,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    def getPaymentMethodName(self):
        return 'PayPalPayment'


    #Methods

registerType(PayPalSettings,PROJECTNAME)
# end of class PayPalSettings

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('PayPalSettings', PayPalSettings)

##/code-section module-footer



