# File: PaymentInformation.py
"""\
Payment Information

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.IPaymentInformation import IPaymentInformation



from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.Currency import Currency, VOC_CURRENCY
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    StringField('method_name',
        widget=StringWidget(
            label="Method Name",
            label_msgid='PloneMallPayment_label_method_name',
            description='Enter a value for Method Name.',
            description_msgid='PloneMallPayment_help_method_name',
            i18n_domain='plonemallpayment',
        ),
        required=1,
    ),
    
    StringField('currency',
        write_permission='Buy item',
        widget=SelectionWidget(
            label='Currency',
            label_msgid='PloneMallPayment_label_currency',
            description='Enter a value for currency.',
            description_msgid='PloneMallPayment_help_currency',
            i18n_domain='plonemallpayment',
        ),
        required=1,
        vocabulary=VOC_CURRENCY,
        default_method="getDefaultCurrency",
    ),
    
    FixedPointField('value',
        write_permission='Buy item',
        widget=DecimalWidget(
            label='Value',
            label_msgid='PloneMallPayment_label_value',
            description='Enter a value for value.',
            description_msgid='PloneMallPayment_help_value',
            i18n_domain='plonemallpayment',
        ),
        required=0,
    ),
    
    BooleanField('confirmed',
        widget=BooleanWidget(
            description="The payment was confirmated?",
            label='Confirmed',
            label_msgid='PloneMallPayment_label_confirmed',
            description_msgid='PloneMallPayment_help_confirmed',
            i18n_domain='plonemallpayment',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PaymentInformation(BaseContent):
    """
    Payment Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IPaymentInformation,)


    # This name appears in the 'add' box
    archetype_name             = 'PaymentInformation'

    portal_type = meta_type    = 'PaymentInformation' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'PaymentInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "PaymentInformation"
    typeDescMsgId              = 'description_edit_paymentinformation'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('getPaymentMethod')
    def getPaymentMethod(self):
        """
        
        """



    security.declarePublic('getPaymentSettings')
    def getPaymentSettings(self):
        """
        
        """

        settings=getToolByName(self,'portal_paymentsettings')
        for s in settings.objectValues:
            if s.getPayment_method()==self.getPayment_method():
                return s



    security.declarePublic('processPayment')
    def processPayment(self):
        """
        
        """
        
        return self.REQUEST.RESPONSE.redirect('%s/thankyou?order_id=%s' % \
                                           (self.portal_url(), self.getOrderId()))


    security.declarePublic('getPaymentMethodName')
    def getPaymentMethodName(self):
        """
        
        """
        
        return self.getMethod_name()


    #methods from Interface IPaymentInformation

    security.declareProtected("View", 'getMethodName')
    def getMethodName(self):
        '''
        
        '''
        
        return self.getMethod_name()



    security.declareProtected("View", 'getPaymentTotal')
    def getPaymentTotal(self):
        '''
        
        '''
        
        return Currency(self.getCurrency(), 0) #self.getValue())



    security.declareProtected("View", 'isPaymentProcessed')
    def isPaymentProcessed(self):
        '''
        
        '''
        
        return self.getProcessed()



    security.declareProtected("View", 'isPaymentConfirmated')
    def isPaymentConfirmated(self):
        '''
        
        '''
        
        return self.getConfirmated()



    security.declarePublic('getSettings')
    def getSettings(self):
        """
        
        """
        
        tool=getToolByName(self,'portal_paymentsettings')
        for o in tool.objectValues():
            if o.getPayment_method()==self.getPaymentMethodName():
                return o


    #manually created methods

    def initiatePaymentProcess(self):
        """
        
        """
        

    def getDefaultCurrency(self):
        return self.portal_mall_registry.getDefaultCurrency()



registerType(PaymentInformation,PROJECTNAME)
# end of class PaymentInformation

##code-section module-footer #fill in your manual code here
if register_payment:
    FactoryRegistry.registerMallFactory('PaymentInformation', PaymentInformation, (IPaymentInformation,))
##/code-section module-footer



