from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from RedirectingPaymentInformation import PaymentInformation
from Products.PloneMallPayment.config import *
from Products.CMFCore.utils import getToolByName

from zLOG import LOG,DEBUG,INFO

POInfoSchema = BaseSchema.copy()

schema= POInfoSchema + Schema((
    StringField(
        'poNumber',
        widget=StringWidget(
            label="PO Number",
            description="The purchase order number",
        ),
    ),
),
)


from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

class PurchaseOrderPaymentInformation(PaymentInformation,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(PaymentInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    portal_type = meta_type = archetype_name = 'PurchaseOrderPaymentInformation'

    global_allow               = 0
    allow_discussion           = 0
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "PurchaseOrderPaymentInformation"
    typeDescMsgId              = 'description_edit_purchaseorderpaymentinformation'

    schema = getattr(PaymentInformation,'schema',Schema(())) + schema

    security.declarePublic('processPayment')
    def processPayment(self):
        """redirect to the purchase order form on site
        """
        self.changeState('initializeProcessing')
        return self.REQUEST.RESPONSE.redirect(self.portal_url() + '/purchase_order')
                                      
    def paymentSuccess(self):
        """Confirm payment and send to afterCheckout
        """
        order = self.aq_parent # the order
        self.setConfirmed(True)  # payment was confirmed
        self.changeState('successProcessing') # change state to success
        po_number = self.REQUEST.SESSION.get('po_number','')
        self.setPoNumber(po_number) # set the PO Number in the payment info
        
        return self.REQUEST.RESPONSE.redirect(order.absolute_url()+ \
                '/afterCheckout')
    
    ## this method should be in PaymentInformation.py                                  
    def changeState(self,transition):
        wft=getToolByName(self,'portal_workflow')
        wft.doActionFor(self,transition)

registerType(PurchaseOrderPaymentInformation,PROJECTNAME)

FactoryRegistry.registerMallFactory('PurchaseOrderPaymentInformation', PurchaseOrderPaymentInformation)
