from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from RedirectingPaymentSettings import RedirectingPaymentSettings
from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings
from Products.PloneMallPayment.config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.IRedirectingPaymentMethod import IRedirectingPaymentMethod

PONumberSchema = BaseSchema.copy()
 
schema= PONumberSchema + Schema((
    
    StringField('payment_method',
        default='purchaseorder',
        widget=StringWidget(
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            description='Enter a value for payment_method.',
            description_msgid='PloneMallPayment_help_payment_method',
            i18n_domain='plonemallpayment',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PurchaseOrderSettings(BaseContent):
    """
    PayPal Settings
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IPaymentSettings,)


    # This name appears in the 'add' box
    portal_type = meta_type = archetype_name = 'PurchaseOrderSettings'

    global_allow               = 0
    allow_discussion           = 0
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "PurchaseOrderSettings"
    typeDescMsgId              = 'description_edit_purchaseordersettings'

    schema = schema

    def listRedirectingPaymentMethods(self):
        """
        
        """
        return self.portal_mall_registry.getSupportedFactoryNames(IRedirectingPaymentMethod)


    #Methods

registerType(PurchaseOrderSettings,PROJECTNAME)
