# File: QentaPaymentInformation.py
"""\
unknown

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from RedirectingPaymentInformation import RedirectingPaymentInformation



from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
import md5
##/code-section module-header

schema= Schema((
    StringField('fingerprint',
        widget=StringWidget(
            label='Fingerprint',
            label_msgid='PloneMallPayment_label_fingerprint',
            description='Enter a value for fingerprint.',
            description_msgid='PloneMallPayment_help_fingerprint',
            i18n_domain='plonemallpayment',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class QentaPaymentInformation(RedirectingPaymentInformation,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(RedirectingPaymentInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'QentaPaymentInformation'

    portal_type = meta_type    = 'QentaPaymentInformation' 
    allowed_content_types      = [] + list(getattr(RedirectingPaymentInformation,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'QentaPaymentInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "QentaPaymentInformation"
    typeDescMsgId              = 'description_edit_qentapaymentinformation'

    schema = BaseSchema + \
             getattr(RedirectingPaymentInformation,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('getPaymentParameters')
    def getPaymentParameters(self):
        """
        returns a dictionary of parameters that will be passed to the
        clearing page.
        intended to be overloaded by  the concrete payment driver
        """
        
        portal=self.portal_url.getPortalObject()
        settings=self.getSettings()
        if not settings:
            raise ValueError,'no settings defined for %s' % self.getMethodName()
        
        language='en'
        
        #if hasattr(self,'portal_languages'):
        #    language=self.portal_languages.getPreferredLanguage()
            
        res={
            'imageURL': portal.absolute_url()+'/'+portal.base_properties.logoName,
            'merchantKey':settings.getMerchantkey(),
            #'secret':settings.getSecret(),
            'currency':self.getCurrency(),
            'amount':float(self.getTotal()),
            'language':language,
            'successURL':self.absolute_url()+'/callbackSuccess',
            'failureURL':self.absolute_url()+'/callbackFailure',
            'cancelURL':self.absolute_url()+'/callbackCancel',
            'serviceURL':self.absolute_url(),
            'paymentType':settings.getDefaultPaymentType(),
            'orderDescription':self.getOrder().getOrderNumber(),
        }
        
        strFingerprint=str(res['merchantKey']) + str(res['amount']) + str(res['currency']) + \
                str(res['language']) + str(res['orderDescription']) + res['successURL'] + \
                res['failureURL'] + res['cancelURL'] + res['serviceURL'] + \
                res['imageURL'] + settings.getSecret()
                
        fingerprint=md5.new(strFingerprint).hexdigest()
        res['requestFingerprint']=fingerprint
        self.update(fingerprint=fingerprint)
        
        return res



    security.declarePublic('getPaymentPageBaseUrl')
    def getPaymentPageBaseUrl(self):
        """
        
        """
        
        return 'https://www.qenta.com/qpay/init-v21.php'



registerType(QentaPaymentInformation,PROJECTNAME)
# end of class QentaPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('QentaPaymentInformation', QentaPaymentInformation)
##/code-section module-footer



