# File: RedirectingPaymentInformation.py
"""\
<p></p>

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from PaymentInformation import PaymentInformation



from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
import urllib
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RedirectingPaymentInformation(PaymentInformation,BaseContent):
    """
    <p></p>
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(PaymentInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'RedirectingPaymentInformation'

    portal_type = meta_type    = 'RedirectingPaymentInformation' 
    allowed_content_types      = [] + list(getattr(PaymentInformation,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'RedirectingPaymentInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "RedirectingPaymentInformation"
    typeDescMsgId              = 'description_edit_redirectingpaymentinformation'

    schema = BaseSchema + \
             getattr(PaymentInformation,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('processPayment')
    def processPayment(self):
        """
        
        """
        #import pdb;pdb.set_trace()
        self.changeState('initializeProcessing')
        if self.getOptionsPage():
            #the answer of this page will be routed to redirectPaymentAction
            return self.showOptionsPage()
        else:
            #no further options to deal with, so lets redirect now
            return self.redirectPayment()



    security.declarePublic('callbackSuccess')
    def callbackSuccess(self,REQUEST):
        """
        
        """
        
        self.changeState('successProcessing')

        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')
        return self.portal_workflow.getInfoFor(self,'review_state')



    security.declarePublic('callbackFailure')
    def callbackFailure(self,REQUEST):
        """
        
        """
        self.changeState('failureProcessing')

        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')
        
        return self.portal_workflow.getInfoFor(self,'review_state')



    security.declarePublic('callbackCancel')
    def callbackCancel(self,REQUEST):
        """
        
        """
        
        self.changeState('cancelProcessing')
        
        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')
        return self.portal_workflow.getInfoFor(self,'review_state')



    security.declarePublic('showOptionsPage')
    def showOptionsPage(self):
        """
        
        """
        page=self.getOptionsPage()
        if page:
            return page()



    security.declarePublic('getOptionsPage')
    def getOptionsPage(self):
        """
        returns the pagetemplate of the options page
        """
        
        id='plonemall_payment_options_%s' % self.getMethodName()
        if hasattr(self,id):
            return getattr(self,id)
        else:
            return None



    security.declarePublic('getPaymentParameters')
    def getPaymentParameters(self):
        """
        returns a dictionary of parameters that will be passed to the
        clearing page.
        intended to be overloaded by  the concrete payment driver
        """
        
        return {}



    security.declarePublic('getPaymentPageUrl')
    def getPaymentPageUrl(self,options={}):
        """
        
        """
        
        base=self.getPaymentPageBaseUrl().strip()
        pars=self.getPaymentParameters()
        pars.update(options)
        parstring=urllib.urlencode(pars)
        if base.endswith('?') or base.endswith('&'):
            res=base+parstring
        else:
            res=base+'?'+parstring
            
        return res



    security.declarePublic('redirectPayment')
    def redirectPayment(self,options={}):
        """
        
        """
        self.changeState('startProcessing')
        
        url=self.getPaymentPageUrl(options)
        return self.REQUEST.RESPONSE.redirect(url)



    security.declarePublic('redirectPaymentAction')
    def redirectPaymentAction(self,REQUEST):
        """
        
        """
        
        options=REQUEST.form
        return self.redirectPayment(options)



    security.declarePublic('getPaymentPageBaseUrl')
    def getPaymentPageBaseUrl(self):
        """
        returns the base Url of the payment provider page such as
        'www.paypal.com'
        """
        
        raise NotImplementedError('getPaymentPageBaseUrl')


    #manually created methods

    def changeState(self,transition):
        wft=getToolByName(self,'portal_workflow')
        wft.doActionFor(self,transition)



registerType(RedirectingPaymentInformation,PROJECTNAME)
# end of class RedirectingPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('RedirectingPaymentInformation', RedirectingPaymentInformation)
##/code-section module-footer



