# File: RedirectingPaymentSettings.py
"""\
the url of the payment privider clearing site

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings



from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.IRedirectingPaymentMethod import IRedirectingPaymentMethod

##/code-section module-header

schema= Schema((
    StringField('merchantkey',
        widget=StringWidget(
            label='Merchantkey',
            label_msgid='PloneMallPayment_label_merchantkey',
            description='Enter a value for merchantkey.',
            description_msgid='PloneMallPayment_help_merchantkey',
            i18n_domain='plonemallpayment',
        ),
    ),
    
    #the url of the payment privider clearing site
    StringField('baseUrl',
        widget=StringWidget(
            label='Baseurl',
            label_msgid='PloneMallPayment_label_baseUrl',
            description='Enter a value for baseUrl.',
            description_msgid='PloneMallPayment_help_baseUrl',
            i18n_domain='plonemallpayment',
        ),
    ),
    
    StringField('payment_method',
        widget=SelectionWidget
        (
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            description='Enter a value for payment_method.',
            description_msgid='PloneMallPayment_help_payment_method',
            i18n_domain='plonemallpayment',
        ),
        vocabulary='listRedirectingPaymentMethods',
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RedirectingPaymentSettings(BaseContent):
    """
    the url of the payment privider clearing site
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IPaymentSettings,)


    # This name appears in the 'add' box
    archetype_name             = 'RedirectingPaymentSettings'

    portal_type = meta_type    = 'RedirectingPaymentSettings' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'RedirectingPaymentSettings.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "RedirectingPaymentSettings"
    typeDescMsgId              = 'description_edit_redirectingpaymentsettings'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('listRedirectingPaymentMethods')
    def listRedirectingPaymentMethods(self):
        """
        
        """
        return self.portal_mall_registry.getSupportedFactoryNames(IRedirectingPaymentMethod)



    security.declarePublic('getPaymentMethodName')
    def getPaymentMethodName(self):
        """
        
        """
        
        return self.getPayment_method()



registerType(RedirectingPaymentSettings,PROJECTNAME)
# end of class RedirectingPaymentSettings

##code-section module-footer #fill in your manual code here
##/code-section module-footer



