# File: IOrder.py
"""\
IOrder

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'




from Interface import Base

class IOrder(Base):
    """
    IOrder
    """

    #Methods

    def getCustomer():
        """
        Return the customer.
        """
        


    def setCustomer(customer):
        """
        Set the customer.
        """
        


    def getCustomerAddress():
        """
        Return the customer address.
        """
        


    def setCustomerAddress(customer_address):
        """
        Set the customer address.
        """
        


    def getCart():
        """
        Return the order cart.
        """
        


    def setCart(cart):
        """
        Set the order cart. Here, a good approach is move the cart from
        the CartManager to inside the Order. It would avoid possible
        problems with session ids conflicts and will turn the
        persistence model more elegant. It's not mandatory, duo the
        placeless design of the interface, but It's a good practice:
        keep everything about an Order inside itself.
        """
        


    def hasShipping():
        """
        Return true if the order has shipping. In some business models,
        shipping information is useless (e.g. a service provider that
        sell hosting plan or a theater that sells tickets).
        """
        


    def getShipping():
        """
        Return the shipping.
        """
        


    def setShipping(shipping):
        """
        Set the shipping.
        """
        


    def getShippingAddress():
        """
        Return the general shipping address.
        """
        


    def setShippingAddress(shipping_address):
        """
        Set the general shipping address.
        """
        


    def hasShippingAddressByItem():
        """
        Return true if the order has different shipping addresses for
        each cart item.
        """
        


    def getShippingAddressByItem(item):
        """
        Return the shipping address for the cart item.
        """
        


    def setShippingAddressByItem(item,shipping_address):
        """
        Set the shipping address for the cart item.
        """
        


    def hasPayment():
        """
        Return true if the order has payment. Could appears strange, but
        in some business models, payment information would be useless
        (e.g. a theater that does tickets reservations instead of really
        sell it by internet; you pay when you get the ticket at the
        movies)
        """
        


    def getPayment():
        """
        Return the payment.
        """
        


    def setPayment(payment):
        """
        Set the payment.
        """
        


    def getPaymentAddress():
        """
        Return the payment address.
        """
        


    def setPaymentAddress(payment_address):
        """
        Set the payment address.
        """
        


    def hasTax():
        """
        Return true if the order has tax. Nowdays, It's a bit hard to
        find a business model that does not need to pay taxes, but a
        good example where payment information is useless are bookstores
        (that does not pay taxes because books are cultural stuff).
        """
        


    def getTax():
        """
        Return the tax.
        """
        


    def setTax(tax):
        """
        Set the tax.
        """
        


    def hasTaxByItem():
        """
        Return true if the order has different taxes for each cart item.
        """
        


    def getTaxByItem(item):
        """
        Return the tax for the cart item.
        """
        


    def setTaxByItem(item,tax):
        """
        Set the tax for the cart item.
        """
        


    def getTotal():
        """
        Return the order total.
        """
        

# end of class IOrder

