from Products.PloneMallRegistry.IPhysicalItem import IPhysicalItem
from Products.PloneMallRegistry.IShippingMethod import IShippingMethod
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.Size import Size
from Products.PloneMallRegistry.Weight import Weight
from util import addShippingInformation
from FedExRate import FedExRate
from zLOG import LOG, INFO

class FedEx:
    '''
    Federal Express
    
    More information at:
    
    http://www.fedex.com/us/
    '''

    __implements__ = (IPhysicalItem, IShippingMethod)


    def getSize(self, item):
        '''
        
        '''
        
        return Size()


    def getWeight(self, item):
        '''
        
        '''
        
        return Weight()


    def processShipping(self, order):
        '''
        
        '''
        cart = order.getCart()
        address = order.address_information_set.shipping_address_information
        w = cart.getWeight()
        #LOG(PROJECTNAME, INFO, "Weight: " + str(w))
        o = { 'weight'         : str(cart.getWeight()),
              'carrierCode'    : 'FDXG',
              'toCountry'      : str(address.getCountry()),
              'toState'        : str(address.getState()),
              'toZip'          : str(address.getPostal_code()),
              'fromCountry'    : 'US',        # needs to get data from
              'fromState'      : 'CA',        # the order instead
              'fromZip'        : '90210',     # of being static
              'packNum'        : str(cart.getPackageCount()),
              'doType'         : 'REGULARPICKUP',
              'service'        : 'FEDEXGROUND',
              'packaging'      : 'YOURPACKAGING'
             }
        
        r = FedExRate("Company Name")
        
        if str(w) == '0.0':
            self.shiprate = '0.0'
        
        else:
            self.shiprate = r.getRate(o)
            
        return addShippingInformation(order, self)

if register_fedex:
    FactoryRegistry.registerMallFactory('FedEx', FedEx, (IShippingMethod, IPhysicalItem), icon_file='fedex.gif')
