# File: FedExInformation.py
"""\
unknown

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 1 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from ShippingInformation import ShippingInformation



from Products.PloneMallShipping.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
##/code-section module-header

schema= Schema((
    StringField('accountNumber',
        widget=StringWidget(
            label='AccountNumber',
            label_msgid='PloneMallShipping_label_accountnumber',
            description='Enter the FedEx account number.',
            description_msgid='PloneMallShipping_help_accountnumber',
            i18n_domain='PloneMallShipping',
        ),
    ),
    
),
)

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class FedExOvernightInformation(ShippingInformation,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(ShippingInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'FedExOvernightInformation'
    portal_type = meta_type    = 'FedExOvernightInformation' 

    allowed_content_types      = [] + list(getattr(ShippingInformation,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'QentaPaymentInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "FedExOvernightInformation"
    typeDescMsgId              = 'description_edit_fedexinformation'

    schema = BaseSchema + \
             getattr(ShippingInformation,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    

    security.declarePublic('getFromAddress')
    def getFromAddress(self):
        """
        returns the address the package is shipped from
        """
        
        
        portal=self.portal_url.getPortalObject()
        settings=self.getSettings()
        if not settings:
            raise ValueError,'no settings defined for %s' % self.getMethodName()
        
        res={
            'imageURL': portal.absolute_url()+'/'+portal.base_properties.logoName,
            'merchantKey':settings.getMerchantkey(),
            'secret':settings.getSecret(),
            'currency':self.getCurrency(),
            'amount':self.getValue(),
            'language':'de',
            'successURL':self.absolute_url()+'/callbackSuccess',
            'failureURL':self.absolute_url()+'/callbackFailure',
            'cancelURL':self.absolute_url()+'/callbackCancel',
            'serviceURL':self.absolute_url(),
            'paymentType':settings.getDefaultPaymentType(),
            'orderDescription':'PloneMall Order',
        }
        
        strFingerprint=res['merchantKey'] + res['amount'] + res['currency'] + \
                res['language'] + res['orderDescription'] + res['successURL'] + \
                res['failureURL'] + res['cancelURL'] + res['serviceURL'] + \
                res['imageURL'] + res['secret']
                
        fingerprint=md5.new(strFingerprint).hexdigest()
        res['requestFingerprint']=fingerprint
        self.update(fingerprint=fingerprint)
        
        return res


registerType(FedExOvernightInformation,PROJECTNAME)
# end of class QentaPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('FedExOvernightInformation', FedExOvernightInformation)
##/code-section module-footer



