# File: ShippingInformation.py
"""\
Shipping Information

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.PloneMallRegistry.IShippingInformation import IShippingInformation



from Products.PloneMallShipping.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.Currency import Currency, VOC_CURRENCY
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    StringField('method_name',
        widget=StringWidget(
            label="Method Name",
            label_msgid='PloneMallShipping_label_method_name',
            description='Enter a value for Method Name.',
            description_msgid='PloneMallShipping_help_method_name',
            i18n_domain='plonemallshipping',
        ),
        required=1,
    ),
    
    StringField('currency',
        vocabulaty="VOC_CURRENCY",
        widget=SelectionWidget
        (
            label='Currency',
            label_msgid='PloneMallShipping_label_currency',
            description='Enter a value for currency.',
            description_msgid='PloneMallShipping_help_currency',
            i18n_domain='plonemallshipping',
        ),
        required=1,
        default_method="getDefaultCurrency",
    ),
    
    FixedPointField('value',
        widget=DecimalWidget(
            label='Value',
            label_msgid='PloneMallShipping_label_value',
            description='Enter a value for value.',
            description_msgid='PloneMallShipping_help_value',
            i18n_domain='plonemallshipping',
        ),
        required=0,
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ShippingInformation(BaseContent):
    """
    Shipping Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IShippingInformation,)


    # This name appears in the 'add' box
    archetype_name             = 'ShippingInformation'

    portal_type = meta_type    = 'ShippingInformation' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'ShippingInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "ShippingInformation"
    typeDescMsgId              = 'description_edit_shippinginformation'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface IShippingInformation

    security.declareProtected("View", 'getMethodName')
    def getMethodName(self):
        '''
        
        '''
        
        return self.getMethod_name()



    security.declareProtected("View", 'getShippingTotal')
    def getShippingTotal(self):
        '''
        
        '''
        
        return Currency(self.getCurrency(), self.getValue())


    #manually created methods

    def getDefaultCurrency(self):
        return self.portal_mall_registry.getDefaultCurrency()



registerType(ShippingInformation,PROJECTNAME)
# end of class ShippingInformation

##code-section module-footer #fill in your manual code here
if register_shipping:
   FactoryRegistry.registerMallFactory('ShippingInformation', ShippingInformation, (IShippingInformation,))
##/code-section module-footer



