# File: EUTaxMethod.py
"""\
unknown

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'


##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
##/code-section module-header


from Products.PloneMallTax.RegionTaxMethod import RegionTaxMethod

class EUTaxMethod(RegionTaxMethod):
    ''' '''
    __implements__ = (getattr(RegionTaxMethod,'__implements__',()),)

    ##code-section class-header_EUTaxMethod #fill in your manual code here
    eu_countries=['LU','IE','DK','AT','BE','FI','NL','UK','GB','DE','SE',
                 'IT','FR','ES','SI','GR','CY','MT','PT','CZ','HU','EE','LT','PL','LV']           
    ##/code-section class-header_EUTaxMethod




    

    def isCountryInEU(self,country):
        return country in self.eu_countries
                

    def hasEUVATId(self,customer):
        vatid=customer.getEUVATId()
        return bool(vatid)
            

    def calcRate(self,order,taxtool):
        shop_country=order.portal_mall_registry.getCountry()
        
        cust = order.getCustomer()
        addressinfoset = cust.getAddress().contentValues()
        address = addressinfoset[0]
    
        country=address.getCountry()
        state= address.getState()        
        taxinfos = taxtool.contentValues()
        
        country_taxes=[taxinfo for taxinfo in taxinfos 
            if taxinfo.getCountry()==country]
            
        if len(country_taxes)==1:
            country_tax=country_taxes[0].getPercent()
        elif len(country_taxes) > 1:
            raise ValueError('more than 1 match for finding a region based tax (%d)' % len(exact_matches))
        else:
            country_tax=0

        shopcountry_taxes=[taxinfo for taxinfo in taxinfos 
            if taxinfo.getCountry()==shop_country]

        if len(shopcountry_taxes)==1:
            shopcountry_tax=shopcountry_taxes[0].getPercent()
        elif len(shopcountry_taxes) > 1:
            raise ValueError('more than 1 match for finding a region based tax (%d)' % len(exact_matches))
        else:
            shopcountry_tax=20
            
        if country==shop_country:
            #in the same country you have to pay VAT
            tax=shopcountry_tax
        elif self.isCountryInEU(country):
            if self.hasEUVATId(cust):
                tax=0
                order.eu_zero_tax=True
            else:
                tax=shopcountry_tax or country_tax
        else:
            tax=0
        
        return tax
                
    
##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('EUTaxMethod', EUTaxMethod)   
##/code-section module-footer



