# File: RegionTax.py
"""\
Region Tax

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.ITaxInformation import ITaxInformation


from Products.PloneMallTax.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.AllowedTypesByIface import AllowedTypesByIface
##/code-section module-header

schema= Schema((
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RegionTax(UniqueObject,AllowedTypesByIfaceMixin,AllowedTypesByIface,BaseFolder):
    """
    Region Tax
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(AllowedTypesByIface,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'RegionTax'

    portal_type = meta_type    = 'RegionTax' 
    allowed_content_types      = ['RegionTaxInformation'] 
    allowed_interfaces = [ITaxInformation] 
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'RegionTax.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "RegionTax"
    typeDescMsgId              = 'description_edit_regiontax'

    actions =  (


       {'action':      "string:$object_url/mall_regiontaxes",
        'category':    "object",
        'id':          'mall_regiontaxes',
        'name':        'mall_regiontaxes',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
        

    )
    #toolicon                   = 'RegionTax.gif'

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        AllowedTypesByIface,BaseFolder.__init__(self,'portal_regiontax')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods
    #manually created methods

    def getRate(self, country, state):
        
        taxinfos = self.contentValues()
        
        country_matches=[taxinfo for taxinfo in taxinfos 
            if taxinfo.getCountry()==country]
            
        exact_matches=[taxinfo for taxinfo in country_matches 
            if taxinfo.getCountry()==country and taxinfo.getState()==state]
        
        if not exact_matches:
            exact_matches=[taxinfo for taxinfo in country_matches 
                if taxinfo.getCountry()==country and not taxinfo.getState()]
            
        if len(exact_matches)==1:
            match=exact_matches[0]
        elif len(exact_matches) > 1:
            raise ValueError('more than 1 match for finding a region based tax (%d)' % len(exact_matches))
        else:
            match=None
        
        if match:
            return match.getPercent()
        


registerType(RegionTax,PROJECTNAME)
# end of class RegionTax

##code-section module-footer #fill in your manual code here
##/code-section module-footer



