# File: RegionTaxInformation.py
"""\
Region Tax Information

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from TaxInformation import TaxInformation


from Products.PloneMallTax.config import *
##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.ITaxInformation import ITaxInformation
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    StringField('country',
        widget=StringWidget(
            label='Country',
            label_msgid='PloneMallTax_label_country',
            description='Enter a value for country.',
            description_msgid='PloneMallTax_help_country',
            i18n_domain='plonemalltax',
        ),
        required=1,
    ),
    
    StringField('state',
        widget=StringWidget(
            label='State',
            label_msgid='PloneMallTax_label_state',
            description='Enter a value for state.',
            description_msgid='PloneMallTax_help_state',
            i18n_domain='plonemalltax',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RegionTaxInformation(TaxInformation,BaseContent):
    """
    Region Tax Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(TaxInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'RegionTaxInformation'

    portal_type = meta_type    = 'RegionTaxInformation' 
    allowed_content_types      = [] + list(getattr(TaxInformation,'allowed_content_types',[]))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'RegionTaxInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "RegionTaxInformation"
    typeDescMsgId              = 'description_edit_regiontaxinformation'

    schema = BaseSchema + \
             getattr(TaxInformation,'schema',Schema(())) + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

registerType(RegionTaxInformation,PROJECTNAME)
# end of class RegionTaxInformation

##code-section module-footer #fill in your manual code here
if register_region_tax:
    FactoryRegistry.registerMallFactory('RegionTaxInformation', RegionTaxInformation, (ITaxInformation,))
##/code-section module-footer



