from Products.PloneMallRegistry.ITaxMethod import ITaxMethod
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from util import addTaxInformation

class RegionTaxMethod:
    '''

    '''

    __implements__ = (ITaxMethod,)

    def processTax(self, order):
        '''
        
        '''
        
        return addTaxInformation(order, self)
    
    def calcRate(self,order,taxtool):
        cust = order.getCustomer()
        addressinfoset = cust.getAddress().contentValues()
        address = addressinfoset[0]
    
        country=address.getCountry()
        state= address.getState()        
        taxinfos = taxtool.contentValues()
        
        country_matches=[taxinfo for taxinfo in taxinfos 
            if taxinfo.getCountry()==country]
            
        exact_matches=[taxinfo for taxinfo in country_matches 
            if taxinfo.getCountry()==country and taxinfo.getState()==state]
        
        if not exact_matches:
            exact_matches=[taxinfo for taxinfo in country_matches 
                if taxinfo.getCountry()==country and not taxinfo.getState()]
            
        if len(exact_matches)==1:
            match=exact_matches[0]
        elif len(exact_matches) > 1:
            raise ValueError('more than 1 match for finding a region based tax (%d)' % len(exact_matches))
        else:
            match=None
        
        if match:
            return match.getPercent()
        

if register_region_tax:
    FactoryRegistry.registerMallFactory('RegionTaxMethod', RegionTaxMethod, (ITaxMethod,))   
