# File: TaxInformation.py
"""\
Tax Information

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from Products.PloneMallRegistry.ITaxInformation import ITaxInformation


from Products.PloneMallTax.config import *
##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.Currency import Currency, VOC_CURRENCY
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema= Schema((
    StringField('tax_type',
        widget=StringWidget(
            label="Type",
            label_msgid='PloneMallTax_label_tax_type',
            description='Enter a value for Type.',
            description_msgid='PloneMallTax_help_tax_type',
            i18n_domain='plonemalltax',
        ),
        required=1,
    ),
    
    StringField('currency',
        widget=SelectionWidget
        (
            label='Currency',
            label_msgid='PloneMallTax_label_currency',
            description='Enter a value for currency.',
            description_msgid='PloneMallTax_help_currency',
            i18n_domain='plonemalltax',
        ),
        required=1,
        vocabulary=VOC_CURRENCY,
        default_method="getDefaultCurrency",
    ),
    
    FixedPointField('value',
        widget=DecimalWidget(
            label='Value',
            label_msgid='PloneMallTax_label_value',
            description='Enter a value for value.',
            description_msgid='PloneMallTax_help_value',
            i18n_domain='plonemalltax',
        ),
        required=0,
        accessor="Value",
    ),
    
    FloatField('percent',
        widget=DecimalWidget(
            label='Percent',
            label_msgid='PloneMallTax_label_percent',
            description='Enter a value for percent.',
            description_msgid='PloneMallTax_help_percent',
            i18n_domain='plonemalltax',
        ),
        required=0,
        accessor="Percent",
    ),
    
    BooleanField('is_included_in_price',
        widget=BooleanWidget(
            description="Is the tax already included in the price?",
            label="Included in Price?",
            label_msgid='PloneMallTax_label_is_included_in_price',
            description_msgid='PloneMallTax_help_is_included_in_price',
            i18n_domain='plonemalltax',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TaxInformation(BaseContent):
    """
    Tax Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (ITaxInformation,)


    # This name appears in the 'add' box
    archetype_name             = 'TaxInformation'

    portal_type = meta_type    = 'TaxInformation' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'TaxInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "TaxInformation"
    typeDescMsgId              = 'description_edit_taxinformation'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ITaxInformation

    security.declareProtected("View", 'getTaxType')
    def getTaxType(self):
        '''
        
        '''
        
        return self.getTax_type()



    security.declareProtected("View", 'getValue')
    def getValue(self):
        '''
        
        '''
        
        return Currency(self.getCurrency(), self.Value())



    security.declareProtected("View", 'getPercent')
    def getPercent(self):
        '''
        
        '''
        
        return self.Percent()



    security.declareProtected("View", 'isIncludedInPrice')
    def isIncludedInPrice(self):
        '''
        
        '''
        
        return self.getIs_included_in_price()


    #manually created methods

    def getDefaultCurrency(self):
        if hasattr(self,'aq_parent'):
            reg = getToolByName(self, 'portal_mall_registry')
            return reg.getDefaultCurrency()
        else:
            return None



registerType(TaxInformation,PROJECTNAME)
# end of class TaxInformation

##code-section module-footer #fill in your manual code here
if register_tax_information:
   FactoryRegistry.registerMallFactory('TaxInformation', TaxInformation, (ITaxInformation,))
##/code-section module-footer



