# File: TaxInformationSet.py
"""\
Tax Information Set

"""
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil), jens quadrat - AGENTUR FUER NEUE MEDIEN OEG (Austria),
# BlueDynamics KEG (Austria), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>, Jens Klein
<jensens@jensquadrat.de>, Phil Auersperg <phil@bluedynamics.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from Products.PloneMallRegistry.ITaxInformationSet import ITaxInformationSet
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.ITaxInformation import ITaxInformation


from Products.PloneMallTax.config import *
##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.Currency import Currency
from Products.PloneMallRegistry.util import filterContents
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.AllowedTypesByIface import AllowedTypesByIface
##/code-section module-header

schema= Schema((
    StringField('method_name',
        widget=StringWidget(
            label="Method Name",
            label_msgid='PloneMallTax_label_method_name',
            description='Enter a value for Method Name.',
            description_msgid='PloneMallTax_help_method_name',
            i18n_domain='plonemalltax',
        ),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TaxInformationSet(AllowedTypesByIfaceMixin,AllowedTypesByIface,BaseFolder):
    """
    Tax Information Set
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(AllowedTypesByIface,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),) + (ITaxInformationSet,)


    # This name appears in the 'add' box
    archetype_name             = 'TaxInformationSet'

    portal_type = meta_type    = 'TaxInformationSet' 
    allowed_content_types      = ['TaxInformation'] 
    allowed_interfaces = [ITaxInformation] 
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'TaxInformationSet.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "TaxInformationSet"
    typeDescMsgId              = 'description_edit_taxinformationset'

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ITaxInformationSet

    security.declareProtected("View", 'getMethodName')
    def getMethodName(self):
        '''
        
        '''
        
        return self.getMethod_name()



    security.declareProtected("View", 'getTaxTotal')
    def getTaxTotal(self, filter = {}):
        '''
        
        '''

        ret = Currency()
        for obj in self.getContents(filter):
            ret += obj.getValue()
        return ret



    security.declareProtected("View", 'getContents')
    def getContents(self, filter = {}):
        '''
        
        '''

        return filterContents(self.objectValues(['TaxInformation']), filter)



registerType(TaxInformationSet,PROJECTNAME)
# end of class TaxInformationSet

##code-section module-footer #fill in your manual code here
if register_tax_information:
    FactoryRegistry.registerMallFactory('TaxInformationSet', TaxInformationSet, (ITaxInformationSet, ))
##/code-section module-footer



