from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.Currency import Currency
from Products.CMFCore.utils import getToolByName

def addTaxInformation(order, method):
    rt = getToolByName(order, 'portal_regiontax')
    cust = order.getCustomer()
    addressinfoset = cust.getAddress().contentValues()
    address = addressinfoset[0]
    
    rate = method.calcRate(order,rt)    
    
    factory = FactoryRegistry.getMallFactory('TaxInformationSet')
    id = 'tax_information_set'
    obj = factory(id)
    order._setObject(id, obj)
    obj = getattr(order, id)
    obj.setMethod_name(method.__class__.__name__)
    
    factory = FactoryRegistry.getMallFactory('TaxInformation')
    id = 'tax_information'
    ti = factory(id)
    obj._setObject(id, ti)
    ti = getattr(obj, id)
    if rate:
        if not order.has_tax_by_item:
            total = float(order.getSubTotal().getValue())
        else:
            total = Currency()
            cart = order.getCart()
            for item in cart.getContents():
                if hasattr(item.getMallItem(), 'taxable_item'):
                    total += item.getTotal()
            total = float(total.getValue())
        tax = rate * total / 100
        ti.setValue(str(tax))
        ti.setPercent(str(rate))
        #ti.setTax_type(str()) needs to be set by the regiontax tool
    
    
    order.setTax(obj)
    return order
